#include "model.h"

Model::Model (QObject *parent, double v, double r) :
     QObject(parent), value(v), rate(r) {}

double Model::getInputValue(void) { return value; }
double Model::getExchangeRate(void) { return rate; }

void Model::setInputValue(double v) {
 if (value == v) return; //Величина не менялась - выйти
 value = v;
 emit resultChanged(value*rate);
  //Иначе послать сигнал, что результат стал другим
}

void Model::setInputValue(QString v) {
 bool ok = false;
 double vs = v.toDouble(&ok);
 if (ok) this->setInputValue(vs);
}

void Model::setExchangeRate(double r) {
 if (rate == r) return;
 rate = r;
 emit resultChanged(value*rate);
}

void Model::setExchangeRate(QString r) {
 bool ok = false;
 double rs = r.toDouble(&ok);
 if (ok) this->setExchangeRate(rs);
}
