#include "simpleview.h"

void SimpleView::setModel(Model * model_) {
 model = model_;
 connect(converted, SIGNAL(textChanged(QString)), model, SLOT(setInputValue(QString)));
 connect(rate, SIGNAL(textChanged(QString)), model, SLOT(setExchangeRate(QString)));
 connect(model, SIGNAL(resultChanged(double)), this, SLOT(convertedValueSlot(double)));
}

SimpleView::SimpleView(QWidget *parent) : QWidget(parent) {
 converted = new QLineEdit(QString("0"),this);
 rate = new QLineEdit(QString("0"),this);
 convertedValue = new QLineEdit(QString("0"),this);
 convertedValue->setReadOnly(true);

 QHBoxLayout *layout = new QHBoxLayout(this);
 layout->setSpacing(4);
 layout->addWidget(new QLabel(QString(tr("Сумма"))));
 layout->addWidget(converted);
 layout->addWidget(new QLabel(QString(tr("Коэффициент"))));
 layout->addWidget(rate);
 layout->addWidget(new QLabel(QString(tr("Результат"))));
 layout->addWidget(convertedValue);
 setLayout(layout);
}

void SimpleView::convertedValueSlot(double d) {
 QString str;
 converted->setText(str.setNum(model->getInputValue()));
 rate->setText(str.setNum(model->getExchangeRate()));
 convertedValue->setText(QString::number(d));
}
