#include "view.h"

void View::setModel(Model * model_) {
  model = model_;

  connect(converted, SIGNAL(valueChanged(double)), model, SLOT(setInputValue(double)));
  connect(rate, SIGNAL(valueChanged(double)), model, SLOT(setExchangeRate(double)));
  connect(model, SIGNAL(resultChanged(double)), this, SLOT(convertedValueSlot(double)));
/*
  //В "новом стиле" и с опцией проекта
  //QMAKE_CXXFLAGS += -std=gnu++11
  //эти строки в версиях QT младше 5.10 выглядели бы так:
  QObject::connect (converted,static_cast<void (QDoubleSpinBox::*)(double)>(&QDoubleSpinBox::valueChanged),
   model, &Model::setInputValue);
  QObject::connect (rate, static_cast<void (QDoubleSpinBox::*)(double)>(&QDoubleSpinBox::valueChanged),
   model, &Model::setExchangeRate);
  QObject::connect (model, static_cast<void (Model::*)(double)>(&Model::resultChanged),
   this, &View::convertedValueSlot);
*/
 }

View::View(QWidget *parent) : QWidget(parent) {
 converted = new QDoubleSpinBox(this);
 converted->setDecimals(2);
 converted->setMaximum(1e6);
 converted->setSingleStep(0.5);

 rate = new QDoubleSpinBox(this);
 rate->setDecimals(2);
 rate->setMaximum(1000);
 rate->setSingleStep(0.5);

 convertedValue = new QLabel(this);

 QGridLayout *layout = new QGridLayout(this);
 layout->setSpacing(4);
 layout->addWidget(new QLabel(QString(tr("Сумма"))),0,0,1,1);
 layout->addWidget(converted,0,1,1,1);
 layout->addWidget(new QLabel(QString(tr("Коэффициент"))),1,0,1,1);
 layout->addWidget(rate,1,1,1,1);
 layout->addWidget(convertedValue,2,0,1,2);
 setLayout(layout);
}

void View::convertedValueSlot(double d) {
 converted->setValue(model->getInputValue());
 rate->setValue(model->getExchangeRate());
 convertedValue->setText("="+QString::number(d,'f',2));
}
